//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: injective/oracle/v1beta1/tx.proto
//

//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import GRPC
import NIO
import SwiftProtobuf


/// Msg defines the oracle Msg service.
///
/// Usage: instantiate `Injective_Oracle_V1beta1_MsgClient`, then call methods of this protocol to make API calls.
internal protocol Injective_Oracle_V1beta1_MsgClientProtocol: GRPCClient {
  var serviceName: String { get }
  var interceptors: Injective_Oracle_V1beta1_MsgClientInterceptorFactoryProtocol? { get }

  func relayPriceFeedPrice(
    _ request: Injective_Oracle_V1beta1_MsgRelayPriceFeedPrice,
    callOptions: CallOptions?
  ) -> UnaryCall<Injective_Oracle_V1beta1_MsgRelayPriceFeedPrice, Injective_Oracle_V1beta1_MsgRelayPriceFeedPriceResponse>

  func relayBandRates(
    _ request: Injective_Oracle_V1beta1_MsgRelayBandRates,
    callOptions: CallOptions?
  ) -> UnaryCall<Injective_Oracle_V1beta1_MsgRelayBandRates, Injective_Oracle_V1beta1_MsgRelayBandRatesResponse>

  func requestBandIBCRates(
    _ request: Injective_Oracle_V1beta1_MsgRequestBandIBCRates,
    callOptions: CallOptions?
  ) -> UnaryCall<Injective_Oracle_V1beta1_MsgRequestBandIBCRates, Injective_Oracle_V1beta1_MsgRequestBandIBCRatesResponse>

  func relayCoinbaseMessages(
    _ request: Injective_Oracle_V1beta1_MsgRelayCoinbaseMessages,
    callOptions: CallOptions?
  ) -> UnaryCall<Injective_Oracle_V1beta1_MsgRelayCoinbaseMessages, Injective_Oracle_V1beta1_MsgRelayCoinbaseMessagesResponse>
}

extension Injective_Oracle_V1beta1_MsgClientProtocol {
  internal var serviceName: String {
    return "injective.oracle.v1beta1.Msg"
  }

  /// RelayPriceFeedPrice defines a method for relaying a price for a price feeder-based oracle
  ///
  /// - Parameters:
  ///   - request: Request to send to RelayPriceFeedPrice.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func relayPriceFeedPrice(
    _ request: Injective_Oracle_V1beta1_MsgRelayPriceFeedPrice,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Injective_Oracle_V1beta1_MsgRelayPriceFeedPrice, Injective_Oracle_V1beta1_MsgRelayPriceFeedPriceResponse> {
    return self.makeUnaryCall(
      path: "/injective.oracle.v1beta1.Msg/RelayPriceFeedPrice",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeRelayPriceFeedPriceInterceptors() ?? []
    )
  }

  /// RelayBandRates defines a method for relaying rates from Band
  ///
  /// - Parameters:
  ///   - request: Request to send to RelayBandRates.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func relayBandRates(
    _ request: Injective_Oracle_V1beta1_MsgRelayBandRates,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Injective_Oracle_V1beta1_MsgRelayBandRates, Injective_Oracle_V1beta1_MsgRelayBandRatesResponse> {
    return self.makeUnaryCall(
      path: "/injective.oracle.v1beta1.Msg/RelayBandRates",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeRelayBandRatesInterceptors() ?? []
    )
  }

  /// RequestBandIBCRates defines a method for fetching rates from Band ibc
  ///
  /// - Parameters:
  ///   - request: Request to send to RequestBandIBCRates.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func requestBandIBCRates(
    _ request: Injective_Oracle_V1beta1_MsgRequestBandIBCRates,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Injective_Oracle_V1beta1_MsgRequestBandIBCRates, Injective_Oracle_V1beta1_MsgRequestBandIBCRatesResponse> {
    return self.makeUnaryCall(
      path: "/injective.oracle.v1beta1.Msg/RequestBandIBCRates",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeRequestBandIBCRatesInterceptors() ?? []
    )
  }

  /// RelayCoinbaseMessages defines a method for relaying price messages from Coinbase API
  ///
  /// - Parameters:
  ///   - request: Request to send to RelayCoinbaseMessages.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func relayCoinbaseMessages(
    _ request: Injective_Oracle_V1beta1_MsgRelayCoinbaseMessages,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Injective_Oracle_V1beta1_MsgRelayCoinbaseMessages, Injective_Oracle_V1beta1_MsgRelayCoinbaseMessagesResponse> {
    return self.makeUnaryCall(
      path: "/injective.oracle.v1beta1.Msg/RelayCoinbaseMessages",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeRelayCoinbaseMessagesInterceptors() ?? []
    )
  }
}

internal protocol Injective_Oracle_V1beta1_MsgClientInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when invoking 'relayPriceFeedPrice'.
  func makeRelayPriceFeedPriceInterceptors() -> [ClientInterceptor<Injective_Oracle_V1beta1_MsgRelayPriceFeedPrice, Injective_Oracle_V1beta1_MsgRelayPriceFeedPriceResponse>]

  /// - Returns: Interceptors to use when invoking 'relayBandRates'.
  func makeRelayBandRatesInterceptors() -> [ClientInterceptor<Injective_Oracle_V1beta1_MsgRelayBandRates, Injective_Oracle_V1beta1_MsgRelayBandRatesResponse>]

  /// - Returns: Interceptors to use when invoking 'requestBandIBCRates'.
  func makeRequestBandIBCRatesInterceptors() -> [ClientInterceptor<Injective_Oracle_V1beta1_MsgRequestBandIBCRates, Injective_Oracle_V1beta1_MsgRequestBandIBCRatesResponse>]

  /// - Returns: Interceptors to use when invoking 'relayCoinbaseMessages'.
  func makeRelayCoinbaseMessagesInterceptors() -> [ClientInterceptor<Injective_Oracle_V1beta1_MsgRelayCoinbaseMessages, Injective_Oracle_V1beta1_MsgRelayCoinbaseMessagesResponse>]
}

internal final class Injective_Oracle_V1beta1_MsgClient: Injective_Oracle_V1beta1_MsgClientProtocol {
  internal let channel: GRPCChannel
  internal var defaultCallOptions: CallOptions
  internal var interceptors: Injective_Oracle_V1beta1_MsgClientInterceptorFactoryProtocol?

  /// Creates a client for the injective.oracle.v1beta1.Msg service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  ///   - interceptors: A factory providing interceptors for each RPC.
  internal init(
    channel: GRPCChannel,
    defaultCallOptions: CallOptions = CallOptions(),
    interceptors: Injective_Oracle_V1beta1_MsgClientInterceptorFactoryProtocol? = nil
  ) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
    self.interceptors = interceptors
  }
}

/// Msg defines the oracle Msg service.
///
/// To build a server, implement a class that conforms to this protocol.
internal protocol Injective_Oracle_V1beta1_MsgProvider: CallHandlerProvider {
  var interceptors: Injective_Oracle_V1beta1_MsgServerInterceptorFactoryProtocol? { get }

  /// RelayPriceFeedPrice defines a method for relaying a price for a price feeder-based oracle
  func relayPriceFeedPrice(request: Injective_Oracle_V1beta1_MsgRelayPriceFeedPrice, context: StatusOnlyCallContext) -> EventLoopFuture<Injective_Oracle_V1beta1_MsgRelayPriceFeedPriceResponse>

  /// RelayBandRates defines a method for relaying rates from Band
  func relayBandRates(request: Injective_Oracle_V1beta1_MsgRelayBandRates, context: StatusOnlyCallContext) -> EventLoopFuture<Injective_Oracle_V1beta1_MsgRelayBandRatesResponse>

  /// RequestBandIBCRates defines a method for fetching rates from Band ibc
  func requestBandIBCRates(request: Injective_Oracle_V1beta1_MsgRequestBandIBCRates, context: StatusOnlyCallContext) -> EventLoopFuture<Injective_Oracle_V1beta1_MsgRequestBandIBCRatesResponse>

  /// RelayCoinbaseMessages defines a method for relaying price messages from Coinbase API
  func relayCoinbaseMessages(request: Injective_Oracle_V1beta1_MsgRelayCoinbaseMessages, context: StatusOnlyCallContext) -> EventLoopFuture<Injective_Oracle_V1beta1_MsgRelayCoinbaseMessagesResponse>
}

extension Injective_Oracle_V1beta1_MsgProvider {
  internal var serviceName: Substring { return "injective.oracle.v1beta1.Msg" }

  /// Determines, calls and returns the appropriate request handler, depending on the request's method.
  /// Returns nil for methods not handled by this service.
  internal func handle(
    method name: Substring,
    context: CallHandlerContext
  ) -> GRPCServerHandlerProtocol? {
    switch name {
    case "RelayPriceFeedPrice":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Injective_Oracle_V1beta1_MsgRelayPriceFeedPrice>(),
        responseSerializer: ProtobufSerializer<Injective_Oracle_V1beta1_MsgRelayPriceFeedPriceResponse>(),
        interceptors: self.interceptors?.makeRelayPriceFeedPriceInterceptors() ?? [],
        userFunction: self.relayPriceFeedPrice(request:context:)
      )

    case "RelayBandRates":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Injective_Oracle_V1beta1_MsgRelayBandRates>(),
        responseSerializer: ProtobufSerializer<Injective_Oracle_V1beta1_MsgRelayBandRatesResponse>(),
        interceptors: self.interceptors?.makeRelayBandRatesInterceptors() ?? [],
        userFunction: self.relayBandRates(request:context:)
      )

    case "RequestBandIBCRates":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Injective_Oracle_V1beta1_MsgRequestBandIBCRates>(),
        responseSerializer: ProtobufSerializer<Injective_Oracle_V1beta1_MsgRequestBandIBCRatesResponse>(),
        interceptors: self.interceptors?.makeRequestBandIBCRatesInterceptors() ?? [],
        userFunction: self.requestBandIBCRates(request:context:)
      )

    case "RelayCoinbaseMessages":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Injective_Oracle_V1beta1_MsgRelayCoinbaseMessages>(),
        responseSerializer: ProtobufSerializer<Injective_Oracle_V1beta1_MsgRelayCoinbaseMessagesResponse>(),
        interceptors: self.interceptors?.makeRelayCoinbaseMessagesInterceptors() ?? [],
        userFunction: self.relayCoinbaseMessages(request:context:)
      )

    default:
      return nil
    }
  }
}

internal protocol Injective_Oracle_V1beta1_MsgServerInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when handling 'relayPriceFeedPrice'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeRelayPriceFeedPriceInterceptors() -> [ServerInterceptor<Injective_Oracle_V1beta1_MsgRelayPriceFeedPrice, Injective_Oracle_V1beta1_MsgRelayPriceFeedPriceResponse>]

  /// - Returns: Interceptors to use when handling 'relayBandRates'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeRelayBandRatesInterceptors() -> [ServerInterceptor<Injective_Oracle_V1beta1_MsgRelayBandRates, Injective_Oracle_V1beta1_MsgRelayBandRatesResponse>]

  /// - Returns: Interceptors to use when handling 'requestBandIBCRates'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeRequestBandIBCRatesInterceptors() -> [ServerInterceptor<Injective_Oracle_V1beta1_MsgRequestBandIBCRates, Injective_Oracle_V1beta1_MsgRequestBandIBCRatesResponse>]

  /// - Returns: Interceptors to use when handling 'relayCoinbaseMessages'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeRelayCoinbaseMessagesInterceptors() -> [ServerInterceptor<Injective_Oracle_V1beta1_MsgRelayCoinbaseMessages, Injective_Oracle_V1beta1_MsgRelayCoinbaseMessagesResponse>]
}
